/usr/sbin/chcontext is in util-vserver 0.30.216-pre2864-2ubuntu1.
This file is owned by root:root, with mode 0o755.
The actual contents of the file can be viewed below.
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 | #! /bin/bash
# $Id: chcontext 2821 2008-11-03 19:52:53Z dhozac $
# Copyright (C) 2004 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
: ${UTIL_VSERVER_VARS:=/usr/lib/util-vserver/util-vserver-vars}
test -e "$UTIL_VSERVER_VARS" || {
echo $"Can not find util-vserver installation (the file '$UTIL_VSERVER_VARS' would be expected); aborting..." >&2
exit 1
}
. "$UTIL_VSERVER_VARS"
. "$_LIB_FUNCTIONS"
function showHelp()
{
echo \
$"Usage: $1 [--cap [!]<cap_name>] [--secure] [--xid <num>] [--disconnect]
[--domainname <name>] [--hostname <name>] [--flag <flags>+]
[--silent] [--] command arguments ...
chcontext allocate a new security context and executes
a command in that context.
By default, a new/unused context is allocated
--cap CAP_NAME
Add a capability from the command. This option may be
repeated several time.
See /usr/include/linux/capability.h
In general, this option is used with the --secure option
--secure removes most critical capabilities and --cap
adds specific ones.
--cap !CAP_NAME
Remove a capability from the command. This option may be
repeated several time.
See /usr/include/linux/capability.h
--xid num
Select the context. On root in context 0 is allowed to
select a specific context.
Context number 1 is special. It can see all processes
in any contexts, but can't kill them though.
Option --xid may be repeated several times to specify up to 16 contexts.
--disconnect
Start the command in background and make the process
a child of process 1.
--domainname new_domainname
Set the domainname (NIS) in the new security context.
Use "none" to unset the domain name.
--flag
Set one flag in the new or current security context. The following
flags are supported. The option may be used several time.
fakeinit: The new process will believe it is process number 1.
Useful to run a real /sbin/init in a vserver.
lock: The new process is trapped and can't use chcontext anymore.
sched: The new process and its children will share a common
execution priority.
nproc: Limit the number of process in the vserver according to
ulimit setting. Normally, ulimit is a per user thing.
With this flag, it becomes a per vserver thing.
private: No one can join this security context once created.
ulimit: Apply the current ulimit to the whole context
--hostname new_hostname
Set the hostname in the new security context
This is need because if you create a less privileged
security context, it may be unable to change its hostname
--secure
Remove all the capabilities to make a virtual server trustable
--silent
Do not print the allocated context number.
Report bugs to <$PACKAGE_BUGREPORT>."
exit $2
}
function showVersion()
{
echo \
$"chcontext $PACKAGE_VERSION -- allocates/enters a security context
This program is part of $PACKAGE_STRING
Copyright (C) 2004 Enrico Scholz
This program is free software; you may redistribute it under the terms of
the GNU General Public License. This program has absolutely no warranty."
exit $1
}
$_VSERVER_INFO - FEATURE migrate || exec $_CHCONTEXT_COMPAT "$@"
tmp=$(getopt -o + --long cap:,ctx:,xid:,disconnect,domainname:,flag:,hostname:,secure,silent,help,version,spaces: -n "$0" -- "$@") || exit 1
eval set -- "$tmp"
OPT_CAPS=()
OPT_CTX=
OPT_DISCONNECT=
OPT_FLAGS=()
OPT_SECURE=
OPT_SILENT=
OPT_INITPID=
OPT_SPACES=--default
while true; do
case "$1" in
--help) showHelp $0 0;;
--version) showVersion 0;;
--cap) OPT_CAPS=( "${OPT_CAPS[@]}" "$2" ); shift;;
--ctx|--xid) OPT_CTX=$2; shift;;
--disconnect) OPT_DISCONNECT=1;;
--domainname) OPT_DOMAINNAME=$2; shift;;
--hostname) OPT_HOSTNAME=$2; shift;;
--flag)
test "$2" != "fakeinit" || OPT_INITPID=--initpid
OPT_FLAGS=( "${OPT_FLAGS[@]}" "$2" )
shift
;;
--secure) OPT_SECURE=1;;
--silent) OPT_SILENT=1;;
--spaces) OPT_SPACES=$2; shift;;
--) shift; break;;
*) echo $"chcontext: internal error; arg=='$1'" >&2; exit 1;;
esac
shift
done
create_cmd=( ${OPT_CTX:+$_VTAG --create --tag "$OPT_CTX" --silentexist --silent --}
$_VSPACE --new $OPT_SPACES --
$_VCONTEXT --create --silentexist
${OPT_SILENT:+--silent}
${OPT_CTX:+--xid "$OPT_CTX"} )
chain_cmd=()
old_IFS=$IFS
IFS=,$IFS
chain_cmd=( "${chain_cmd[@]}"
--
$_VSPACE --set $OPT_SPACES )
test -z "$OPT_DOMAINNAME$OPT_HOSTNAME" || \
chain_cmd=( "${chain_cmd[@]}"
--
$_VUNAME --set --xid self
${OPT_DOMAINNAME:+-t domainname="$OPT_DOMAINNAME"}
${OPT_HOSTNAME:+ -t nodename="$OPT_HOSTNAME"} )
chain_cmd=( "${chain_cmd[@]}"
--
$_VATTRIBUTE --set
${OPT_SECURE:+--secure}
${OPT_CAPS:+--bcap "${OPT_CAPS[*]}"}
${OPT_FLAGS:+--flag "${OPT_FLAGS[*]}"} )
migrate_cmd=( $_VCONTEXT
${OPT_SILENT:+--silent}
${OPT_DISCONNECT:+--disconnect}
$OPT_INITPID )
IFS=$old_IFS
$_VSERVER_INFO -q "$OPT_CTX" XIDTYPE static
is_static=$?
test -z "$OPT_CTX"
is_dynamic=$?
if test "$is_dynamic" -eq 0 || test "$is_static" -eq 0; then
"${create_cmd[@]}" "${chain_cmd[@]}" -- \
"${migrate_cmd[@]}" --endsetup --migrate-self -- "$@"
rc=$?
else
rc=254
fi
if test "$is_static" -eq 0; then
migrate_cmd=( $_VTAG --migrate --tag "$OPT_CTX" --silent -- \
$_VSPACE --enter "$OPT_CTX" $OPT_SPACES -- \
"${migrate_cmd[@]}" )
fi
test "$rc" -ne 254 || exec "${migrate_cmd[@]}" --xid "$OPT_CTX" --migrate -- \
"$@"
exit $rc
|